#include <windows.h>
#include "mIRC_Interface.h"
#include <vector>

using namespace std;

CgIRC girc;

// (C) Bad HAL 9000 (Pat Bigler)
// If you use this code please credit myself, pooface, Misha130, and OLLI
// kthx bai



int CgIRC::GetTotalNets()
{
	_snprintf(szData, MAX_BUFFER_SIZE, "$scon(0)");
	SendMessage(hwndmIRC, WM_EVALUATE, 0, 0);

	return atoi(szData);
}

void CgIRC::GetNetName(int net, char *out)
{
	_snprintf(szData, MAX_BUFFER_SIZE, "$scon(%i).network", net);
	SendMessage(hwndmIRC, WM_EVALUATE, 0, 0);

	_snprintf(out, MAX_BUFFER_SIZE, szData);
}

int CgIRC::GetActiveNet()
{
	_snprintf(szData, MAX_BUFFER_SIZE, "$cid");
	SendMessage(hwndmIRC, WM_EVALUATE, 0, 0);
	int iCid = atoi(szData);

	for (int i=1; i < GetTotalNets() + 1; i++)
	{
		_snprintf(szData, MAX_BUFFER_SIZE, "$scon(%i).cid", i);
		SendMessage(hwndmIRC, WM_EVALUATE, 0, 0);

		if (iCid == atoi(szData))
		{
			return i;
		}

	}
	return 0;

}


int CgIRC::GetTotalChannels(int net)
{
	/*
	// CHANNELS
	sprintf(szData, "/alias ChannelCount { var %%i = $chan(0) | return %%i }" );
	SendMessage(hwndmIRC, WM_MCOMMAND, 1, 0);

	sprintf(szData,"/alias ChannelLast { /set -n %%gmirc_lastchan $chan($1) }" );
	SendMessage(hwndmIRC, WM_MCOMMAND, 1, 0);
	*/
	_snprintf(szData, MAX_BUFFER_SIZE, "$scon(%i).ChannelCount", net);
	SendMessage(hwndmIRC, WM_EVALUATE, 0, 0);

	return atoi(szData);
}


void CgIRC::GetChannelName(int net, int channel, char *out)
{

	_snprintf(szData, MAX_BUFFER_SIZE, "/scon %i ChannelLast %i", net, channel);
	SendMessage(hwndmIRC, WM_MCOMMAND, 1, 0);

	// Read
	_snprintf(szData, MAX_BUFFER_SIZE, "%%gmirc_lastchan");
	SendMessage(hwndmIRC, WM_EVALUATE, 0, 0);

	_snprintf(out, MAX_BUFFER_SIZE, szData);

}

int CgIRC::GetActiveChannel()
{
	_snprintf(szData, MAX_BUFFER_SIZE, "$active");
	SendMessage(hwndmIRC, WM_EVALUATE, 0, 0);
	char szChannel[MAX_BUFFER_SIZE];
	_snprintf(szChannel, MAX_BUFFER_SIZE, szData);

	for (int i=1; i < GetTotalChannels(GetActiveNet())+1; i++)
	{
		_snprintf(szData, MAX_BUFFER_SIZE, "$chan(%i)", i);
		SendMessage(hwndmIRC, WM_EVALUATE, 0, 0);

		if (!strcmp(szChannel, szData))
		{
			return i;
		}

	}
	return 0;
}

void CgIRC::SetActiveChannel(int net, int channel)
{
	// Wow, talk about hacky!
	char szChanbuf[256] = "";
	GetChannelName(net,channel,szChanbuf);
	_snprintf(szData, MAX_BUFFER_SIZE, "/scon %i window -a %s", net, szChanbuf);
	SendMessage(hwndmIRC, WM_MCOMMAND, 1, 0);
}


void CgIRC::SendTextToChannel(int net, int channel, char *in)
{
	_snprintf(szData, MAX_BUFFER_SIZE, "/scon %i msg $chan(%i) %s", net, channel, in);
	SendMessage(hwndmIRC, WM_MCOMMAND, 1, 0);

}


void CgIRC::SendToActiveChannel(char *in)
{
	char szTemp[MAX_BUFFER_SIZE] = "";
	_snprintf(szTemp, MAX_BUFFER_SIZE, "/scon %i msg $chan(%i) %s", GetActiveNet(), GetActiveChannel(), in);
	_snprintf(szData, MAX_BUFFER_SIZE, szTemp);
	SendMessage(hwndmIRC, WM_MCOMMAND, 1, 0);


}


int CgIRC::GetTotalUsers(int net, int channel)
{
	_snprintf(szData, MAX_BUFFER_SIZE, "/scon %i UpdateUserCount %i", net, channel);
	SendMessage(hwndmIRC, WM_MCOMMAND, 1, 0);

	_snprintf(szData, MAX_BUFFER_SIZE, "%%gmirc_usercount");
	SendMessage(hwndmIRC, WM_EVALUATE, 0, 0);

	return atoi(szData);
}


void CgIRC::GetUserName(int net, int channel, int user, char *out)
{

	_snprintf(szData, MAX_BUFFER_SIZE, "/scon %i UpdateUserName %i %i", net, channel, user);
	SendMessage(hwndmIRC, WM_MCOMMAND, 1, 0);

	_snprintf(szData, MAX_BUFFER_SIZE, "%%gmirc_lastuser");
	SendMessage(hwndmIRC, WM_EVALUATE, 0, 0);

	_snprintf(out, MAX_BUFFER_SIZE, szData);

}


int CgIRC::GetTotalLines(int net, int channel)
{
	_snprintf(szData, MAX_BUFFER_SIZE, "/scon %i UpdateLineCount %i", net, channel);
	SendMessage(hwndmIRC, WM_MCOMMAND, 1, 0);

	_snprintf(szData, MAX_BUFFER_SIZE, "%%gmirc_linecount");
	SendMessage(hwndmIRC, WM_EVALUATE, 0, 0);

    return atoi(szData);
}


void CgIRC::GetLine(int net, int channel, int line, char *out)
{

	_snprintf(szData, MAX_BUFFER_SIZE, "/scon %i UpdateLineLast %i %i", net, channel, line);
	SendMessage(hwndmIRC, WM_MCOMMAND, 1, 0);

	_snprintf(szData, MAX_BUFFER_SIZE, "%%gmirc_lastline");
	SendMessage(hwndmIRC, WM_EVALUATE, 0, 0);

	_snprintf(out, MAX_BUFFER_SIZE, szData);
}

void CgIRC::RawEval(char *in, char *out)
{

	_snprintf(szData, MAX_BUFFER_SIZE, in);
    SendMessage(hwndmIRC, WM_EVALUATE, 0, 0);
	
	strcpy(out, szData);

}

void CgIRC::RawSend(char *in)
{
	_snprintf(szData, MAX_BUFFER_SIZE, in);
	SendMessage(hwndmIRC, WM_MCOMMAND, 1, 0);
}


void CgIRC::Init()
{
	hFileMap = CreateFileMapping(INVALID_HANDLE_VALUE,0,PAGE_READWRITE,0,4096,"mIRC");
	szData = (LPSTR)MapViewOfFile(hFileMap,FILE_MAP_ALL_ACCESS,0,0,0); 
	hwndmIRC = FindWindow("mIRC",NULL);


	// Build the scripts!

	if(hwndmIRC)
	{

	// CHANNELS
	sprintf(szData, "/alias ChannelCount { var %%i = $chan(0) | return %%i }" );
	SendMessage(hwndmIRC, WM_MCOMMAND, 1, 0);

	sprintf(szData,"/alias ChannelLast { /set -n %%gmirc_lastchan $chan($1) }" );
	SendMessage(hwndmIRC, WM_MCOMMAND, 1, 0);

	// USERS
	sprintf(szData, "/alias UpdateUserCount { /set -n %%gmirc_usercount $nick($chan($1),0) }");
	SendMessage(hwndmIRC, WM_MCOMMAND, 1, 0);

	sprintf(szData, "/alias UpdateUserName { /set -n %%gmirc_lastuser $nick($chan($1),$2) }");
	SendMessage(hwndmIRC, WM_MCOMMAND, 1, 0);

	// LINES OF TEXT IN CHANNEL
	sprintf(szData, "/alias UpdateLineCount { /set -n %%gmirc_linecount $strip($line($chan($1),0)) }" );
	SendMessage(hwndmIRC, WM_MCOMMAND, 1, 0);

	sprintf(szData,"/alias UpdateLineLast { /set -n %%gmirc_lastline $strip($line($chan($1),$2)) }" );
	SendMessage(hwndmIRC, WM_MCOMMAND, 1, 0);

	}

}

void CgIRC::ShutDown()
{
	if(IsmIRCOpen()){

	// Erase all the old aliases to stay neat
	// CHANNELS
	sprintf(szData, "/alias ChannelCount" );
	SendMessage(hwndmIRC, WM_MCOMMAND, 1, 0);

	sprintf(szData,"/alias ChannelLast" );
	SendMessage(hwndmIRC, WM_MCOMMAND, 1, 0);

	// USERS
	sprintf(szData, "/alias UpdateUserCount");
	SendMessage(hwndmIRC, WM_MCOMMAND, 1, 0);

	sprintf(szData, "/alias UpdateUserName");
	SendMessage(hwndmIRC, WM_MCOMMAND, 1, 0);

	// LINES OF TEXT IN CHANNEL
	sprintf(szData, "/alias UpdateLineCount" );
	SendMessage(hwndmIRC, WM_MCOMMAND, 1, 0);

	sprintf(szData,"/alias UpdateLineLast" );
	SendMessage(hwndmIRC, WM_MCOMMAND, 1, 0);

	}	

	 UnmapViewOfFile(szData); 
	 CloseHandle(hFileMap);
}

bool CgIRC::IsmIRCOpen()
{
	hwndmIRC = FindWindow("mIRC",NULL);

	if(hwndmIRC)
		return true;
	else 
		return false;
}