#pragma once


// How many lines do we want to store?
#define MAX_IRC_LINES 400

// I think I am going overkill here...
#define MAX_BUFFER_SIZE 560


#define WM_EVALUATE WM_USER + 201
#define WM_MCOMMAND  WM_USER + 200


class CgIRC
{
public:
	
	void Init();
	void ShutDown();

	bool IsmIRCOpen();

	CgIRC() { Init(); }


	// This can be used in any way, so a user can ask for any data they want
	void RawEval(char *in, char *out);

	// Send directly to console
	void RawSend(char *in);

	// Server information
	int GetTotalNets();
	void GetNetName(int net, char *out);
	int GetActiveNet();
	

	// Channel information
	int GetTotalChannels(int net);
	void GetChannelName(int net, int channel, char *out);
	int GetActiveChannel();
	void SetActiveChannel(int net, int channel);
	void SendToActiveChannel(char *in);
	void SendTextToChannel(int net, int channel, char *in);

	// User information
	int GetTotalUsers(int net, int channel);
	void GetUserName(int net, int channel, int user, char *out);

	// Lines from channels
	int GetTotalLines(int net, int channel);
	void GetLine(int net, int channel, int line, char *out);


private:
	HANDLE	hFileMap;
	LPSTR	szData;
	HWND	hwndmIRC;
};

extern CgIRC girc;